#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <assert.h>


#ifdef DEBUG
#define DBG(x) x
#else
#define DBG(x)
#endif

#define SLASH 0
#define BACK 1

#define LEFT 0
#define RIGHT 1
#define TOP 2
#define BOT 3

int ik[4] = {0,0,-1,1};
int jk[4] = {-1,1,0,0};
int trans[4] = {RIGHT, LEFT, BOT, TOP};
int zk[2][4] = {{TOP, BOT, LEFT, RIGHT}, {BOT, TOP, RIGHT, LEFT}};


FILE * in;

int field[100][100];
int gr[100][100][4];
int jmax, imax;

int do_p (int i, int j, int k) {
	int ti, tj, tk, len = 0;
	ti = i; tj = j; tk = k;
	while (1) {
		if (gr[ti][tj][tk] >0)
			return -1;
		++len;
		gr[ti][tj][tk] = len;
		tk = zk[field[ti][tj]][tk];
		gr[ti][tj][tk] = len;
		ti = ti + ik[tk];
		tj = tj + jk[tk];
		tk = trans[tk];

		if ((ti == i) && (tj == j) && (tk == k)) break;
		if ((ti < 0) || (ti >= imax) || (tj < 0) || (tj >= jmax))
			return -1;
	}
	return len;
}

int main () {
	int i,j,k,kase=1;
	char line[100];
	int best, len, circ;

	in = fopen ("maze.in", "r");

	while (1) {
		best = -1; circ = 0;
		fscanf (in, "%d %d ", &jmax, &imax);
		if (jmax == 0) break;
		for (i=0; i<imax; ++i) {
			fgets (line, 100, in);
			for (j=0; j<jmax; ++j) {
				field[i][j] = (line[j] == '/')?SLASH:BACK;
				for (k=0; k<4; ++k) {
					gr[i][j][k] = 0;
				}
			}
		}
		for (i=0; i<imax; ++i) {
			for (j=0; j<jmax; ++j) {
				for (k=0; k<4; ++k) {
					if (gr[i][j][k] == 0) {
						len = do_p (i,j,k);
						if (len > best) {
							best = len;
						}
						if (len > 0)
							circ ++;
					}
				}
			}
		}
		printf ("Maze #%d:\n", kase++);
		if (circ <= 0) {
			printf ("There are no cycles.\n\n");
		} else {
			printf ("%d Cycles; the longest has length %d.\n\n", circ, best);
		}
	}
	return 0;
}


